extern crate serde_json;
use crate::parser;
use rayon::prelude::*;
use serde::ser::{Serialize, SerializeStruct, Serializer};
use serde_json::json;

impl Serialize for parser::QryData {
    fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
    where
        S: Serializer,
    {
        // 34 (42) is the number of fields in the struct.
        let mut state = serializer.serialize_struct("parser::QryData", 34)?;
        state.serialize_field("time", &self.time)?;
        state.serialize_field("ether_header.ether_dhost", &self.ether_header.ether_dhost)?;
        state.serialize_field("ether_header.ether_shost", &self.ether_header.ether_shost)?;
        state.serialize_field("ether_header.ether_type", &self.ether_header.ether_type)?;
        state.serialize_field("ipv4_header", &self.ipv4_header)?;
        state.serialize_field("ipv6_header", &self.ipv6_header)?;
        state.serialize_field("tcp_header", &self.tcp_header)?;
        state.serialize_field("udp_header", &self.udp_header)?;
        state.serialize_field("arp_header", &self.arp_header)?;
        state.serialize_field("data", &self.data)?;
        state.serialize_field("reg_res", &self.reg_res)?;
        state.end()
    }
}

pub fn serialize_packets(v: Vec<parser::QryData>) -> Vec<serde_json::Value> {
    // let mut packets_serialized: Vec<_> = Vec::new();

    // for packet in v.iter() {
    //    // packets_serialized.push(json!(&packet));
    // }

    /* rayon parallelized */
    let packets_serialized = v.par_iter().map(|x| json!(x)).collect();

    packets_serialized
}
